// Generated by CoffeeScript 1.9.3
(function() {
  var React, _, mousetrap, shortcuts;

  React = require('react');

  _ = require('lodash');

  mousetrap = require('mousetrap');

  shortcuts = React.createFactory('shortcuts');

  module.exports = React.createClass({
    displayName: 'Shortcuts',
    contextTypes: {
      shortcuts: React.PropTypes.object.isRequired
    },
    propTypes: {
      handler: React.PropTypes.func.isRequired,
      name: React.PropTypes.string.isRequired,
      element: React.PropTypes.func,
      tabIndex: React.PropTypes.number,
      className: React.PropTypes.string,
      eventType: React.PropTypes.string,
      stopPropagation: React.PropTypes.bool
    },
    getDefaultProps: function() {
      return {
        eventType: null,
        stopPropagation: null
      };
    },
    _bindShortcuts: function(shortcutsArr) {
      var element;
      element = React.findDOMNode(this.refs.shortcuts);
      return mousetrap(element).bind(shortcutsArr, this._handleShortcuts, this.props.eventType);
    },
    _unbindShortcuts: function(shortcutsArr) {
      var element;
      element = React.findDOMNode(this.refs.shortcuts);
      return mousetrap(element).unbind(shortcutsArr);
    },
    _onUpdate: function() {
      var shortcutsArr;
      shortcutsArr = this.context.shortcuts.getShortcuts(this.props.name);
      this._unbindShortcuts(shortcutsArr);
      return this._bindShortcuts(shortcutsArr);
    },
    componentDidMount: function() {
      var shortcutsArr;
      shortcutsArr = this.context.shortcuts.getShortcuts(this.props.name);
      this._bindShortcuts(shortcutsArr);
      return this.context.shortcuts.addUpdateListener(this._onUpdate);
    },
    componentWillUnmount: function() {
      this.context.shortcuts.removeUpdateListener(this._onUpdate);
      return this._unbindShortcuts();
    },
    _handleShortcuts: function(e, keyName) {
      var shortcutName;
      e.preventDefault();
      if (this.props.stopPropagation) {
        e.stopPropagation();
      }
      shortcutName = this.context.shortcuts.findShortcutName(keyName, this.props.name);
      return this.props.handler(shortcutName);
    },
    render: function() {
      var element;
      element = shortcuts;
      if (_.isFunction(this.props.element)) {
        element = this.props.element;
      }
      return element({
        tabIndex: this.props.tabIndex || -1,
        className: this.props.className,
        ref: 'shortcuts'
      }, this.props.children);
    }
  });

}).call(this);
