// Generated by CoffeeScript 1.9.3
(function() {
  var EventEmitter, ShortcutManager, _, helpers, invariant,
    extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  _ = require('lodash');

  invariant = require('invariant');

  EventEmitter = require('events').EventEmitter;

  helpers = require('./helpers');

  ShortcutManager = (function(superClass) {
    extend(ShortcutManager, superClass);

    ShortcutManager.CHANGE_EVENT = 'shortcuts:update';

    function ShortcutManager(keymap) {
      if (keymap == null) {
        keymap = {};
      }
      this._keymap = keymap;
    }

    ShortcutManager.prototype.addUpdateListener = function(callback) {
      invariant(callback, 'addUpdateListener: callback argument is not defined or falsy');
      return this.on(ShortcutManager.CHANGE_EVENT, callback);
    };

    ShortcutManager.prototype.removeUpdateListener = function(callback) {
      return this.removeListener(ShortcutManager.CHANGE_EVENT, callback);
    };

    ShortcutManager.prototype._platformName = helpers.getPlatformName();

    ShortcutManager.prototype._parseShortcutDescriptor = function(item) {
      if (_.isPlainObject(item)) {
        return _.get(item, this._platformName);
      } else {
        return item;
      }
    };

    ShortcutManager.prototype.addKeymap = function(keymap) {
      invariant(keymap, 'addKeymap: keymap argument is not defined or falsy.');
      return this._keymap = keymap;
    };

    ShortcutManager.prototype.setKeymap = function(keymap) {
      invariant(keymap, 'setKeymap: keymap argument is not defined or falsy.');
      this._keymap = keymap;
      return this.emit(ShortcutManager.CHANGE_EVENT);
    };

    ShortcutManager.prototype.getAllShortcuts = function() {
      return this._keymap;
    };

    ShortcutManager.prototype.getShortcuts = function(componentName) {
      var _parseShortcutDescriptor, cursor, shortcuts;
      invariant(componentName, 'getShortcuts: name argument is not defined or falsy.');
      cursor = this._keymap[componentName];
      invariant(cursor, "getShortcuts: There are no shortcuts with name " + componentName + ".");
      _parseShortcutDescriptor = this._parseShortcutDescriptor.bind(this);
      shortcuts = _(cursor).map(_parseShortcutDescriptor).flatten().value();
      return shortcuts;
    };

    ShortcutManager.prototype.findShortcutName = function(keyName, componentName) {
      var cursor, result;
      invariant(keyName, 'findShortcutName: keyName argument is not defined or falsy.');
      invariant(componentName, 'findShortcutName: componentName argument is not defined or falsy.');
      cursor = this._keymap[componentName];
      result = _.findKey(cursor, (function(_this) {
        return function(item) {
          var index;
          if (_.isArray(item)) {
            index = item.indexOf(keyName);
            if (index >= 0) {
              return item[index] === keyName;
            }
          } else if (_.isPlainObject(item)) {
            return _.get(item, _this._platformName) === keyName;
          } else {
            return item === keyName;
          }
        };
      })(this));
      return result;
    };

    return ShortcutManager;

  })(EventEmitter);

  module.exports = ShortcutManager;

}).call(this);
